package ca.ubc.cs.mylyn.monitor.usage.editor;

import org.eclipse.jface.viewers.ILazyContentProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;

public class ModelListContentProvider implements ILazyContentProvider {
	protected ListModel<?> model;
	protected TableViewer viewer;
	
	public ModelListContentProvider() {
		super();
	}

	public void dispose() {

	}

	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		if(viewer instanceof TableViewer) {
			this.viewer = (TableViewer)viewer;
		}
		if(newInput instanceof ListModel<?>) {
			model = (ListModel<?>)newInput;
		}
	}

	public Object[] getElements(Object inputElement) {
		if(inputElement == model) {
			return model.getElements().toArray();
		}
		return null;
	}

	public void updateElement(int index) {
		if(viewer != null && model != null && index < model.size()) {
			viewer.replace(model.get(index), index);
		}
	}

}
