/*******************************************************************************
 * Copyright (c) 2004 - 2006 University Of British Columbia and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     University Of British Columbia - initial API and implementation
 *******************************************************************************/

package ca.ubc.cs.mylyn.monitors.parts;

import org.eclipse.swt.widgets.ScrollBar;
import org.eclipse.swt.widgets.Scrollable;
import org.eclipse.ui.IWorkbenchPart;

/**
 * A listener for the scrolling of some control within a workbench part.
 * The listener will be notified when <em>the user</em> causes some
 * scrolling to be performed in some widget; the listener will not be notified
 * of scrolling due to output or changes in the part.  It is not possible for the listener 
 * to prevent the scrolling.
 * 
 *	Implementors may want to perform some test such as
 *		if(scrollBar == scrollable.getHorizontalBar()) {
 *			// ignore horizontal scrolling
 * 	}
 * @author bsd
 */
public interface IPartScrollingListener {

	public void partScrolled(String partId, IWorkbenchPart part, Scrollable scrollable, ScrollBar scrollBar);
}
