/*******************************************************************************
 * Copyright (c) 2004 - 2006 University Of British Columbia and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     University Of British Columbia - initial API and implementation
 *******************************************************************************/

package ca.ubc.cs.mylyn.monitors.parts;

import java.util.List;

import org.eclipse.jface.text.source.ILineRange;
import org.eclipse.jface.text.source.LineRange;

public class LineRangeDifferences extends IntervalDifferences<ILineRange> {

	public LineRangeDifferences(List<ILineRange> before, List<ILineRange> after) {
		super(before, after);
	}

	@Override
	protected int getStart(ILineRange interval) {
		return interval.getStartLine();
	}

	@Override
	protected int getEnd(ILineRange interval) {
		return interval.getStartLine() + interval.getNumberOfLines() - 1;
	}

	@Override
	protected ILineRange split(ILineRange exemplar, int start, int end) {
		return new LineRange(start, end - start + 1);
	}

}
