package ca.ubc.cs.mylyn.monitors.parts.jdt;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.internal.ui.packageview.PackageExplorerPart;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ui.IViewPart;

import ca.ubc.cs.mylyn.monitors.parts.AbstractTreeViewerMonitor;

/**
 * Monitor branch expansions and collapses for Package Explorers,
 * noting the handles of elements whose visibility are changes.
 * @author Brian de Alwis
 */
@SuppressWarnings("restriction")
public class PackageExplorerMonitor extends AbstractTreeViewerMonitor {

	public PackageExplorerMonitor() {
		// TODO Auto-generated constructor stub
	}
	@Override
	protected String[] getPartIds() {
		return new String[] { "org.eclipse.jdt.ui.PackageExplorer" };
	}

	@Override
	protected TreeViewer getTreeViewer(IViewPart part) {
		if(part instanceof PackageExplorerPart) {
			return ((PackageExplorerPart)part).getTreeViewer();
		}
		return null;
	}
	
	@Override
	protected String getKind(Object me) {
		if(me instanceof IJavaElement) {
			return "java";
		}
		return "unknown";
	}

	@Override
	protected String getHandle(Object me) {
		if(me instanceof IJavaElement) {
			return ((IJavaElement)me).getHandleIdentifier();
		}
		return me.toString();
	}
}
