package ca.ubc.cs.mylyn.monitors.parts.platform;

import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPathEditorInput;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.editors.text.TextEditor;

import ca.ubc.cs.mylyn.monitors.parts.AbstractTextEditorMonitor;

public class DefaultTextEditorViewportMonitor extends AbstractTextEditorMonitor {

	public DefaultTextEditorViewportMonitor() {
	}

	@Override
	protected String[] getPartIds() {
		return new String[] { "org.eclipse.ui.DefaultTextEditor" };
	}

	@Override
	protected String getStructureHandle(IWorkbenchPart part) {
		TextEditor editor = (TextEditor)part;
		IEditorInput input = editor.getEditorInput(); 
		if (input instanceof IPathEditorInput) {
			return ((IPathEditorInput) input).getPath().toPortableString();
		}
		return input.getToolTipText();
	}

	@Override
	protected String getStructureKind(IWorkbenchPart part) {
		TextEditor editor = (TextEditor)part;
		if (editor.getEditorInput() instanceof IPathEditorInput) {
			return "file";
		}
		return "unknown";
	}

}
