package ca.ubc.cs.mylyn.monitors.parts.platform;

import org.eclipse.core.resources.IResource;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.navigator.CommonNavigator;

import ca.ubc.cs.mylyn.monitors.parts.AbstractTreeViewerMonitor;

public class ProjectExplorerMonitor extends AbstractTreeViewerMonitor {

	public ProjectExplorerMonitor() {
		// TODO Auto-generated constructor stub
	}

	@Override
	protected String[] getPartIds() {
		return new String[] { "org.eclipse.ui.navigator.ProjectExplorer" };
	}

	@Override
	protected TreeViewer getTreeViewer(IViewPart part) {
		if (part instanceof CommonNavigator) {
			return ((CommonNavigator)part).getCommonViewer();
		}
		return null;
	}
	
	@Override
	protected String getKind(Object me) {
		if(me instanceof IJavaElement) {
			return "java";
		} else if(me instanceof IResource) {
			return "file";
		}
		return "unknown";
	}

	@Override
	protected String getHandle(Object me) {
		if(me instanceof IJavaElement) {
			return ((IJavaElement)me).getHandleIdentifier();
		} else if(me instanceof IResource) {
			return ((IResource)me).getFullPath().toPortableString();
		}
		return "?: " + me.getClass().getName() + ": "
			+ me.toString();
	}
}
